require "import" 
import "android.widget.*" 
import "com.androlua.*" 
import "android.content.Intent"
import "android.net.Uri"

layout = {
    GridView,
    id = "grid",
    numColumns = 1,
    layout_width = "fill",
    layout_height = "fill"
}

items = {"english", "hindi", "marathi", "Subscribe to Channel"}
dlg = LuaDialog(this)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(items))

dlg.setTitle("Welcome! Click on a language to start voice typing")
dlg.setButton("Close", nil)
dlg.show()

grid.onItemClick = function(l, v)
    dlg.dismiss()
    task(20, function()
        if v.text == "english" then
            startSpeechRecognition("en-IN")
        elseif v.text == "hindi" then
            startSpeechRecognition("hi-IN")
        elseif v.text == "marathi" then
            startSpeechRecognition("mr-IN")
        elseif v.text == "Subscribe to Channel" then
            -- Open YouTube link for subscription
            local intent = Intent(Intent.ACTION_VIEW, Uri.parse("https://youtu.be/wpeMcZA2bBo?si=wzAmor0UvKP3Ifm1"))
            this.startActivity(intent)
        end
    end)
end

function startSpeechRecognition(language)
    require "import"
    import "android.speech.SpeechRecognizer"
    import "android.speech.RecognitionListener"
    import "android.speech.RecognizerIntent"
    
    local function destroySpeechRecognizer(rec)
        if rec then
            rec.destroy()
            rec = nil
        end
    end
    
    local speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)
    local recognitionListener = RecognitionListener{
        onResults = function(results)
            local resultArray = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            if resultArray ~= nil and resultArray.size() > 0 then
                local recognizedText = resultArray.get(0)
                local editText = service.getEditText()
                service.insertText(editText, recognizedText .. "। ")
                service.speak(recognizedText)
            end
            destroySpeechRecognizer(speechRecognizer)
        end,
        onError = function()
            destroySpeechRecognizer(speechRecognizer)
        end
    }
    
    local recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, language)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())
    
    speechRecognizer.setRecognitionListener(recognitionListener)
    speechRecognizer.startListening(recognizerIntent)
end